/*
 *  main.c
 *  FileTesto
 *
 *  Created by Stefano Guerrini on 12/03/07.
 *
 */

#include <stdio.h>
#include <string.h>
#include "definizioni.h"

int main (int argc, const char *argv[]) {

	int ret;
	const char *setin, *setout, *finname, *foutname;
	FILE *fin, *fout;
	
    if (argc < 5) {
		ret = errore(FT_ERR_COMMAND_LINE, "main", "Numero di argomenti insufficiente");
		return ret;
	}
	
	if (argc > 5) {
		ret = errore(FT_ERR_COMMAND_LINE, "main", "Troppi argomenti");
		return ret;
	}

	setin = argv[1];
	setout = argv[2];
	finname = argv[3];
	foutname = argv[4];
	
	if (strlen(setin) != strlen(setout)) {
		ret = errore(FT_ERR_SETS, "main", "Gli insiemi di caratteri da sostituire hanno lunghezze diverse");
		return ret;
	}

	if ((fin = fopen(finname, "r")) == NULL) {
		char str[256] = { '\0' };
		sprintf(str, "Impossibile aprire il file '%s'", finname);
		ret = errore(FT_ERR_FILE, "main", str);
		return ret;
	}
	
	if ((fout = fopen(foutname, "w")) == NULL) {
		char str[256] = { '\0' };
		sprintf(str, "Impossibile aprire il file '%s'", foutname);
		ret = errore(FT_ERR_FILE, "main", str);
		fclose(fin);	// chiude file aperto
		return ret;
	}
	
	ret = translate(fin, fout, setin, setout);
	
	fclose(fin);
	fclose(fout);
	
	return ret;
}
